################ Skin package

package provide Skin 0.1

namespace eval Skin {
	variable c
	variable it
}

#####################
proc ::Skin::_mkbody {name c body} {
	set c1 [list variable c]
	set c2 [list set name $name]
	set c3 [list set c $c]
	set body [split $body \n]
	set newbody [join [concat [list $c1] [list $c2] [list $c3] \
		$body] \n]
	#puts "_mkbody: $newbody"
	return $newbody
}

proc ::Skin::_configure {name c arglst} {
	variable it
	if {[llength $arglst] == 0} {
		return [array get it $name$c,*]
	} else {
		foreach {opt val} $arglst {
			set it($name$c,$opt) $val
		}
	}
}

proc ::Skin::label {x y args} {
	variable c
	variable it
	set name [$c create text $x $y -anchor nw \
		-font {Helvetica -12 bold} -fill white]
	set it($name$c) $name
	foreach {opt val} $args {
		set it($name$c,$opt) $val
	}
	$c bind $name <ButtonRelease-1> [list ::Skin::$name$c _invoke]
	
	proc ::Skin::$name$c {cmd args} [_mkbody $name $c { 
		;# label
		variable it
		switch $cmd {
		"_invoke" {
			if {[info exists it($name$c,-command)]} {
				uplevel #0 $it($name$c,-command)
			}
		}
		"_update" {
			set val [set ::$it($name$c,-variable)]
			$c itemconfig $name -text [format $it($name$c,-format) $val]
		}
		"configure" {
			return [_configure $name $c $args]
		}
		}
	}]
	$name$c _update
	trace variable ::$it($name$c,-variable) w [list ::Skin::$name$c _update]
	return ::Skin::$name$c
}

proc ::Skin::linklist {name x y args} {
	variable c
	variable it
	set it($name$c) $name
	foreach {opt val} $args {
		set it($name$c,$opt) $val
	}
	set it($name$c,x) $x
	set it($name$c,y) $y
	proc ::Skin::$name$c {cmd args} [_mkbody $name $c { 
		;# text
		variable it
		switch $cmd {
		"set" {
			catch {$c delete $name}
			set xi $it($name$c,x)
			set yi $it($name$c,y)
			foreach {lst} [lindex $args 0] {
				foreach {val lbl} $lst {}
				set item [$c create text $xi $yi -anchor nw -text "* $lbl" \
					-fill royalblue -font {courier -12 bold underline} \
					-width $it($name$c,-width) -tags $name]
				set bb [$c bbox $name]
				set yi [lindex $bb 3]
				$c bind $item <1> \
					[list uplevel #0 $it($name$c,-command) $item $val]
			}
		}
		"configure" {
			return [_configure $name $c $args]
		}
		}
	}]
	return ::Skin::$name$c
}

proc ::Skin::text {x y args} {
	variable c
	variable it
	set name [$c create text $x $y -anchor nw -font {Courier -12}]
	set it($name$c) $name
	foreach {opt val} $args {
		set it($name$c,$opt) $val
	}
	set it($name$c,txt) ""
	$c itemconfig $name -width $it($name$c,-width)
	
	proc ::Skin::$name$c {cmd args} [_mkbody $name $c { 
		;# text
		variable it
		switch $cmd {
		"add" {
			set s ""
			foreach {txt tag} [lindex $args 0] {
				append s $txt
			}
			set it($name$c,txt) "$s\n$it($name$c,txt)"
			$c itemconfig $name -text $it($name$c,txt)
			$name$c _clip
		}
		"_clip" {
			set bb [$c bbox $name]
			while {[expr [lindex $bb 3]-[lindex $bb 1]] \
					> $it($name$c,-height)} {
				set txt [$c itemcget $name -text]
				set e [string last \n $txt]
				if {$e >= 0} {
					$c itemconfig $name -text [string range $txt 0 [expr $e-1]]
				}
				set bb [$c bbox $name]
				#update
			}
		}
		"configure" {
			return [_configure $name $c $args]
		}
		}
	}]
	return ::Skin::$name$c
}

proc ::Skin::entry {x y args} {
	variable c
	variable it
	set name [$c create text $x $y -anchor nw]
	set it($name$c) $name
	set it($name$c,-font) {Courier -12 bold}
	foreach {opt val} $args {
		set it($name$c,$opt) $val
	}
	if {![info exists ::$it($name$c,-variable)]} {
		set ::$it($name$c,-variable) "*"
	}
	$c itemconfig $name -font $it($name$c,-font)
	set it($name$c,w) [expr \
		($it($name$c,-width)/[font measure $it($name$c,-font) "n"])] 
	
	$c bind $name <1> [list ::Skin::$name$c _edit %x %y]
	$c bind $name <Any-KeyPress> [list ::Skin::$name$c _add %A]
	#$c bind $name <Left> [list ::Skin::$name$c _left]
	#$c bind $name <Right> [list ::Skin::$name$c _right]
	$c bind $name <BackSpace> [list ::Skin::$name$c _backsp]
	$c bind $name <Return> [list ::Skin::$name$c _done]
	$c bind $name <Tab> [list ::Skin::$name$c _done]
	trace variable ::$it($name$c,-variable) w [list ::Skin::$name$c _update]
	
	proc ::Skin::$name$c {cmd args} [_mkbody $name $c { 
		;# button
		variable it
		switch $cmd {
		_update {
			set val [set ::$it($name$c,-variable)]
			set n [string length $val]
			set dspval [string range $val [expr $n-$it($name$c,w)] $n]
			$c itemconfig $name -text $dspval
			$c icursor $name end
		}
		_edit {
			#focus $c
			#$c focus $name
			::Skin::$name$c focus
			$c icursor $name @[lindex $args 0],[lindex $args 1]
			#$c icursor $name end
		}
		_add {
			#$c insert $name insert [lindex $args 0]
			#set ::$it($name$c,-variable) [$c itemcget $name -text]
			append ::$it($name$c,-variable) [lindex $args 0]
			$name$c _update
		}
		_right {
			set i [$c index $name insert]
			$c icursor $name [expr $i+1]
		}
		_left {
			set i [$c index $name insert]
			$c icursor $name [expr $i-1]
		}
		_backsp {
			#set i [expr [$c index $name insert]-1]
			#if {$i >= 0} {
			#	$c dchars $name $i
			#}
			set val [set ::$it($name$c,-variable)]
			set ::$it($name$c,-variable) [string range $val 0 end-1]
			$name$c _update
		}
		_done {
			$c focus ""
			#set ::$it($name$c,-variable) [$c itemcget $name -text]
			if {[info exists it($name$c,-command)]} {
				uplevel #0 $it($name$c,-command)
			}
		}
		focus {
			focus $c
			$c focus $name
			$c icursor $name end
		}
		"configure" {
			return [_configure $name $c $args]
		}
		}
	}]
	::Skin::$name$c _update
	# create an auxiliary string for focus detection
	#set bbox [$c create text $x $y -anchor nw -font $it($name$c,-font) \
	#	-text [string repeat "n" $it($name$c,w)] -fill {}]
	set bbox [$c create image $x $y -anchor nw -image \
		[image create photo -width $it($name$c,-width) \
		-height [font metrics $it($name$c,-font) -linespace]]]
	$c bind $bbox <1> [list ::Skin::$name$c focus]
			
	return ::Skin::$name$c
}

proc ::Skin::scale {x y args} {
	variable c
	variable it
	set name [$c create image $x $y -anchor nw]
	set it($name$c) $name
	foreach {opt val} $args {
		set it($name$c,$opt) $val
	}
	$c itemconfig $name -image $it($name$c,-image)
	set it($name$c,x) $x
	set it($name$c,y) $y
	set it($name$c,pos) 0
	$c bind $name <Enter> [list $c itemconfig $name \
		-image $it($name$c,-imageactive)]
	$c bind $name <Leave> [list $c itemconfig $name \
		-image $it($name$c,-image)]
	$c bind $name <ButtonPress-1> [list ::Skin::$name$c _savepos %X]
	$c bind $name <B1-Motion> [list ::Skin::$name$c _set %X ]
	$c bind $name <ButtonRelease-1> [list ::Skin::$name$c _endset %X]
	
	proc ::Skin::$name$c {cmd args} [_mkbody $name $c { 
		;# scale
		variable it
		switch $cmd {
		"_update" {
			#set it($name$c,pos) [expr [set ::$it($name$c,-variable)]+$it($name$c,x)]
			set it($name$c,pos) [set ::$it($name$c,-variable)]
			set xx [expr $it($name$c,x)+$it($name$c,pos)*$it($name$c,-width)/100]
			$c coords $name $xx $it($name$c,y)
		}
		"_savepos" {
			set it($name$c,x0) [lindex $args 0]
			set it($name$c,xi) [expr $it($name$c,pos)*$it($name$c,-width)/100]
			$c itemconfig $name -image $it($name$c,-imagepressed)
		}
		"_set" {
			set dx [expr [lindex $args 0] - $it($name$c,x0)]
			set x1 [expr $it($name$c,xi) + $dx]
			set wid $it($name$c,-width)
			if {$x1 > $wid} {
				set x1 $wid
			}
			if {$x1 < 0} {
				set x1 0
			}
			set it($name$c,x1) [expr $it($name$c,x)+$x1]
			$c coords $name $it($name$c,x1) $it($name$c,y)
			### update variable
			set value [expr ($it($name$c,x1)-$it($name$c,x))*100/$it($name$c,-width)]
			set it($name$c,pos) $value
			set ::$it($name$c,-variable) $value
			uplevel #0 $it($name$c,-command)
		}
		"_endset" {
			set value [expr ($it($name$c,x1)-$it($name$c,x))*100/$it($name$c,-width)]
			set it($name$c,pos) $value
			set ::$it($name$c,-variable) $value
			$c itemconfig $name -image $it($name$c,-imageactive)
			$name$c invoke
		}
		"invoke" {
			$c itemconfig $name -image $it($name$c,-imageactive)
			uplevel #0 $it($name$c,-command)
		}
		"configure" {
			return [_configure $name $c $args]
		}
		}
	}]
	$name$c _update
	trace variable ::$it($name$c,-variable) w [list ::Skin::$name$c _update]
	return ::Skin::$name$c
}

proc ::Skin::button {x y args} {
	variable c
	variable it
	set name [$c create image $x $y -anchor nw]
	set it($name$c) $name
	foreach {opt val} $args {
		set it($name$c,$opt) $val
	}
	$c itemconfig $name -image $it($name$c,-image)
	$c bind $name <Enter> [namespace code \
		[list $c itemconfig $name -image $it($name$c,-imageactive)]]
	$c bind $name <Leave> [namespace code \
		[list $c itemconfig $name -image $it($name$c,-image)]]
	$c bind $name <ButtonPress-1> [namespace code \
		[list $c itemconfig $name -image $it($name$c,-imagepressed)]]
	$c bind $name <ButtonRelease-1> [list ::Skin::$name$c _invoke]

	proc ::Skin::$name$c {cmd args} [_mkbody $name $c { 
		;# button
		variable it
		switch $cmd {
		_invoke {
			$c itemconfig $name -image $it($name$c,-imageactive)
			after 50 uplevel #0 $it($name$c,-command)
		}
		invoke {
			uplevel #0 $it($name$c,-command)
		}
		"configure" {
			return [_configure $name $c $args]
		}
		}
	}]
	return ::Skin::$name$c
}

proc ::Skin::led {x y args} {
	variable c
	variable it
	set name [$c create image $x $y -anchor nw]
	set it($name$c) $name
	foreach {opt val} $args {
		set it($name$c,$opt) $val
	}
	$c itemconfig $name -image $it($name$c,-imageoff)
	proc ::Skin::$name$c {cmd args} [_mkbody $name $c { 
		;# led
		variable it
		switch $cmd {
		on {
			$c itemconfig $it($name$c) -image $it($name$c,-imageon)
		}
		off {
			$c itemconfig $it($name$c) -image $it($name$c,-imageoff) 
		}
		flash {
			catch {after cancel $it($name$c,flash_after)}
			$c itemconfig $it($name$c) -image $it($name$c,-imageon)
			if {[llength $args] > 0} {
				set dly [lindex $args 0]
			} else {
				set dly 1000
			}
			set it($name$c,flash_after) \
			[after $dly $c itemconfig $it($name$c) -image $it($name$c,-imageoff)]
		}
		"configure" {
			return [_configure $name $c $args]
		}
		}
	}]
	return ::Skin::$name$c
}

proc ::Skin::init {w args} {
	variable c
	set c $w
	catch { $c delete all }
	catch {array unset it *$c}
	foreach {opt val} $args {
		switch -- $opt {
		-image {
			$c create image 0 0 -anchor nw -image $val
		}
		}
	}
}

